#ifdef WIN32
#include "env.h"
#endif
//TODO: Implement all the below(CGI/1.1 compliance):
    //PATH_INFO
    //PATH_TRANSLATED
    //SCRIPT_NAME
    //QUERY_STRING
    //REMOTE_HOST
    //REMOTE_ADDR
    //AUTH_TYPE
    //REMOTE_USER
    //REMOTE_IDENT
    //CONTENT_TYPE
    //CONTENT_LENGTH
    //HTTP_ACCEPT
    //HTTP_USER_AGENT
//TODO: Implement some Apache variables:
    //SERVER_ADMIN
    //SERVER_SIGNATURE


//#include "url.h"
int seticgi(){
    //Set server we are running, MINE!
    if(setenv("SERVER_SOFTWARE", ServerName, 1))
        return 0;
    //We are speaking CGI version 1.1, right?
    if(setenv("GATEWAY_INTERFACE", "CGI/1.1", 1))
        return 0;
    //What else?!
    if(setenv("SERVER_PROTOCOL", "HTTP/1.1", 1))
        return 0;
    return 1;
    }
//TODO: Implement URI disecting functions before anything!
void setdcgi(char * server, char * port, char * method, char * uri, char * referer, char * remoteaddr, char * httpaccept, char *useragent, char *contenttype, char * query){
    //Set Request Method(POST, GET, etc)
    if(method == NULL)
    	setenv("HTTP/1.0", method, 1);
    else
    	setenv("REQUEST_METHOD", method, 1);
    //set server name
    if(server != NULL)
    	setenv("SERVER_NAME", server, 1);
    //set server port
    if(port != NULL)
    	setenv("SERVER_PORT", port, 1);
    if(uri != NULL)
    	setenv("SCRIPT_NAME", uri, 1);
    if(referer != NULL)
    	setenv("HTTP_REFERER", referer, 1);
    if(remoteaddr != NULL)
    	setenv("REMOTE_ADDR", remoteaddr, 1);
    if(httpaccept != NULL)
    	setenv("HTTP_ACCEPT", httpaccept, 1);
    if(useragent != NULL)
    	setenv("HTTP_USER_AGENT", useragent, 1);
    if(contenttype != NULL)
    	setenv("CONTENT_TYPE", contenttype, 1);
    if(query != NULL)
    	setenv("QUERY_STRING", query, 1);
    }    
