/*
WARNING: SUPPORT FOR ONLY 1 RUNNING SERVER IS SUPPORT(BECAUSE OF MUTEXS)
*/




struct RequestData {
 char *method;                 //GET, POST, etc.
 char *protocol;               //Holds "HTTP/0.9", "HTTP/1.0", "HTTP/1.1"
 char *url;             //in the request "GET / HTTP/1.1\n\n", "/" is the requestURI
 char *query;            //Anything after the ?
 char *host;                 //server DNS-name/ip (ie karlan.us.to, or 24.5.83.93)
 char *contenttype;           //Content-Type, TODO: allocate space, or point to array?
 char *useragent;        
 char *connection;        
 char *range;                  
 char *referer; 
 char *accept;
 char *cookie;
 char *from;
 char *transferencoding;
 
 /*
 TODO: when support is added for these, the will be used, otherwise they just take up more space
 char *authorization;
 
 char *acceptencoding;
 char *acceptcharset;
 char *acceptcharset;
 char *acceptcharset;
 */
 
 char *data;
 
 size_t contentlength;        //Length of the data in Content_Length = number of sets of octects(this is default on most PCs)
 size_t keepalive;
 };
 
 
#include "test.h"
#include "url.h"
#include "response.h"
#include "request.h"


//Passed to handleRequest, used as wrapper
struct rConnection{
        
 //File descriptor for remote connection    
 int socketd;
 //Information about remote connection
 struct sockaddr_in AddrInfo;
 };   
//Passed to handleRequest, used as wrapper
struct acceptInfo{
 struct serverConf *serverconf;
 
 struct rConnection connectiondata;
 
 };   
 
  

//int ProcessRequest()
//int   


//Any accepted connection will be passed here, this is will be a newly spawned thread
//Deals with accepting request, and responding to it, remain connected if required...
void handleRequest(void * handleconnection){
  char * recvBuffer;
  RequestData requestdata;
  int returnval;

  //Copy Data from argument to new memory location, so serverListen can use it's space
  struct rConnection connectionInfo = ((*(struct acceptInfo *)handleconnection).connectiondata);
  struct serverConf serverconfig = (*(*(struct acceptInfo *)handleconnection).serverconf);
  
  returnval = Request(connectionInfo.socketd, &requestdata, &serverconfig);
  if(returnval != 0){
  	cout << "Request error...\n";
  	goto destroy_thread;
	}  
	
  returnval = Response(connectionInfo.socketd, &requestdata, &serverconfig);
  if(returnval != 0){
  	cout << "Response error...\n";
  	goto destroy_thread;
	} 

  returnval = 0;
  destroy_thread:         //This is my first goto, EVER
  if(returnval > 300){
  	cout << "HTTP ERROR RESPONSE\n";
  	RespondError(connectionInfo.socketd, returnval, &requestdata, &serverconfig, FindServer(&serverconfig, "all"));
	}
  
  
  if(returnval != 0){
      switch(returnval){
          case EMALLOC:
              cout << "MALLOC ERROR\n";
              break;
          case EOTHER:
              cout << "RANDOM ERROR\n";
              break;
          case EMALICIOUS:
              cout << "MALICIOUS URL ERROR\n";
              break;
          case ESYNTAX:
              cout << "SYNTAX ERROR\n";
              break;
          case ECONNECTION:
              cout << "CONNECTION ERROR\n";
              break;
          default:
              cout << "UNKOWN ERROR\n";
              break;
          }
      }
  
  close(connectionInfo.socketd);
  free(recvBuffer);
  freeRequestData(&requestdata);
  }    




//This will spawn a new server
//If address is NULL, INADDR_ANY is used
//TODO: CLEAN UP THIS AREA, ASAP!!!!!!!!!!!!!
int serverListen(char * address, int port, struct serverConf *serverconf){
    size_t maxThreads = PTHREAD_THREADS_MAX;
  
  #ifdef WIN32
    {WSADATA wsaData;
    WSAStartup(MAKEWORD(1,1), &wsaData);}
  #endif


 int bindd;  //socket descriptor for location we are binding to
 struct sockaddr_in bindAddr;//Info about binded socket, used for socket functions
 
 
//// if(remoteInfo == NULL)
  // exit(1);
 pthread_t *requestThreads = (pthread_t *)malloc(maxThreads * sizeof(pthread_t));//Used for thread initialization
 if(requestThreads == NULL)
   return 1;
   //TODO: FREE THIS MEMORY AT ANY TIME? NO? 
 
 if( (bindd = socket(AF_INET, SOCK_STREAM,0)) == -1){
    perror("socket");
   return 2;
    } 
 bindAddr.sin_family = AF_INET;
 bindAddr.sin_port = htons(port);
 if(address == NULL)
 	bindAddr.sin_addr.s_addr = INADDR_ANY;
 else
 	bindAddr.sin_addr.s_addr = inet_addr(address);
 memset(&(bindAddr.sin_zero), 0, 8);
 
 
 if( bind(bindd, (struct sockaddr *)&bindAddr, sizeof(struct sockaddr)) == -1){
   close(bindd);
   // perror("bind");
   return 3;
    } 
 if( listen(bindd, 20) == -1){
   close(bindd);
   // perror("listen");
   return 4;
    } 
    
    
    
    
 
 socklen_t sin_size = sizeof(struct sockaddr);//I really don't know why I have to use a real address, but whatever
 
 struct acceptInfo *remoteInfo = (struct acceptInfo *)malloc(sizeof(struct acceptInfo));//Used for thread initialization
 //pthread_mutex_t argCopy_Mutex = PTHREAD_MUTEX_INITIALIZER;//Used to prevent collision
 // remoteInfo->argMutex = &argCopy_Mutex;
  remoteInfo->serverconf = serverconf;
  signal(SIGCHLD, SIG_IGN);
 while(1){
   // while(pthread_mutex_trylock(&argCopy_Mutex) == EBUSY){}
    if( (remoteInfo->connectiondata.socketd = accept(bindd, (struct sockaddr *)&remoteInfo->connectiondata.AddrInfo, &sin_size)) == -1){
            //perror("accept");
            continue;
            }
            
  cout << "\nConnection: " << inet_ntoa(remoteInfo->connectiondata.AddrInfo.sin_addr) << endl;
  cout.flush();
  //TODO: serverListen: add support for destorying threads(pthread_destory), and using different thread pointers
  //COMMENT: Used for max thread allocation rules
  /*  while(pthread_mutex_trylock(&allocatedThreads_Mutex) == EBUSY){}
    if(allocatedThreads >= maxThreads){
       cout << "Connection dropped, thread limit(" << maxThreads << ") reached. \"" << __FILE__ << ":" << __LINE__ << "\"" << endl;
       pthread_mutex_unlock(&allocatedThreads_Mutex);
       pthread_mutex_unlock(&argCopy_Mutex);
       continue;
       }*/
           
      int forkdes = fork();
      if(forkdes == 0){
      	handleRequest((void *)remoteInfo);
	exit(0);
	}
      if(forkdes == -1){
      	cout << "FORK ERROR!\n";
	exit(1);
	}
  	close(remoteInfo->connectiondata.socketd);
  
       
    
    } 
 }       
      
