//Functions here are probaly for CGI programs, and shouldn't be implemented at all in server?

//used for taking a hex value between 0-FF(255) and returning its corresponding
//character, this function will be used in process of unescaping URLs 
char hextochar(char value1, char value2){
     char charHex[3] = {value1,
                        value2,
                        0}; //can hold two values and a 0;
     return (char)strtol(charHex, NULL, 16);
     }     
int unescape(char ** string){
    size_t stringSize = strlen(*string);     
    char * tString = (char *)malloc((stringSize + 1) * sizeof(char));  
    if(tString == NULL)
        return EMALLOC;
    char copyChar;
    size_t posNew = 0;
    size_t posOld = 0;
    //strcpy(tString, *string);
    for(; posOld < stringSize ; posOld++, posNew++){
        copyChar = (*string)[posOld];
        if(copyChar == '%' && posOld + 2 < stringSize){
            copyChar = hextochar((*string)[posOld + 1],(*string)[posOld + 2]);
            posOld += 2;
            }
        else if(copyChar == '%' && posOld + 2 >= stringSize){
            free(tString);
            return ESYNTAX;
            }
        tString[posNew] = copyChar;
        }
    tString[posNew] = 0;
    free(*string);
    *string = (char *)malloc((strlen(tString) + 1) * sizeof(char));
    if(*string == NULL){
            free(tString);
            return EMALLOC;
           }
    
    strcpy(*string, tString);
    free(tString);
    return 0;
    }
