#ifdef WIN32
  #include <winsock.h>
  #ifndef socklen_t
    #define socklen_t int
  #endif
#else
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <netinet/in.h>
  #include <arpa/inet.h>
  #include <sys/wait.h>
  #include <signal.h>
#endif

 int sendall(int socketd, char *buf, int len)
    {
    	int returnval = 0;
	int justsent;
	char * sendpnt = &buf[0];
	for(size_t leftsend = strlen(buf) ; leftsend > 0 ; ){
		justsent = send(socketd, sendpnt, leftsend, 0);
		if(justsent == -1 ||
		   justsent == 0){
			returnval = ECONNECTION;
			break;
			}
		sendpnt = &sendpnt[justsent];
		leftsend -= justsent;
		}
    return returnval;
    } 

