//Misc portable(Unix, windows) functions which are usefull

string UniqueDir(string BaseDirectory,string Uniqness = "temp"){
	Directory TestDir(".");
	char tBuff[15];
	for(size_t UniqueCounter = 1 ; UniqueCounter != 0 ; UniqueCounter++){
		sprintf(tBuff, "%d", UniqueCounter);
		if(!TestDir.CD(BaseDirectory + Uniqness + tBuff)){
			return BaseDirectory + Uniqness + tBuff;
			}
		}
	return "";
	}
	
#ifndef WIN32
int GetTempPath(size_t tSize, char *tString){
    if(tSize < 6)
    	return 0;
    //Its a unix world after all!
    tString[0] = '/';
    tString[1] = 't';
    tString[2] = 'm';
    tString[3] = 'p';
    tString[4] = '/';
    tString[5] = 0;
    return 1;
    }
#endif

//
int GetTempFileNameALT(string Dir, string Uniqness, char *tBuffer){
	#ifdef WIN32
	return GetTempFileName(Dir.data(),Uniqness.data(),0,tBuffer);
	#endif
	///It should loop back around with any compiler right....?
	
	char tBuff[15];
	//Lets try the first one....
	for(size_t UniqueCounter = 1 ; UniqueCounter != 0 ; UniqueCounter++){
		sprintf(tBuff, "%d", UniqueCounter);
		if(!FileTest(Dir + Uniqness + tBuff)){
			strncpy(tBuffer, (Dir + Uniqness + tBuff).data(), PATH_MAX);
			return 1;
			}
		}
	//And a second?...!!!!
	for(size_t UniqueCounter = 1 ; UniqueCounter != 0 ; UniqueCounter++){
		sprintf(tBuff, "%d", UniqueCounter);
		if(!FileTest(Dir  + tBuff + Uniqness)){
			strncpy(tBuffer, (Dir + tBuff + Uniqness).data(), PATH_MAX);
			return 1;
			}
		}
	return 0;
	}

string TemporaryFile(string Prefix = "tmp"){
    //Function to generate temp file will not accept anything larger
        char TempDirBuf[PATH_MAX - 14];
        //I have no clue why it failed, but it doesn't matter
        if(GetTempPath(PATH_MAX - 14,TempDirBuf) == 0){
                return "";
                }
        char TempFileBuf[PATH_MAX];
        if(GetTempFileNameALT(TempDirBuf,"kas",TempFileBuf) == 0){
                return "";
                }
        return TempFileBuf;
        }
string TemporaryDir(){
    //Function to generate temp file will not accept anything larger
        char TempDirBuf[PATH_MAX - 14];
        //I have no clue why it failed, but it doesn't matter
        if(GetTempPath(PATH_MAX - 14,TempDirBuf) == 0){
                return "";
                }
        return UniqueDir(TempDirBuf) + PATHSLASH;
        }
